import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class HijoMayor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class HijoMayor  extends Personaje
{
    private int actuaciones;
    private int actTotal;
    private int yIni;
    
    public HijoMayor(){
        super("Mayor",".png",4);
        teclaL = "d";
        teclaU = teclaL.toUpperCase();
        actTotal = actuaciones = 6;
        tecla = new Boton(teclaU, Color.orange, actTotal);
    } 
    
    public void addedToWorld(World world){
        yIni = getY();
        escen = (Escenario)getWorld();
        escen.addObject(tecla, getX(), 326);
    }
    
    public void accion(){    
        if(actuaciones == actTotal){
            Greenfoot.playSound("arrastrar.mp3");
            setImage("MayorAct.png");
            setLocation(getX(),yIni + 10);
        }
        actuaciones--;
        if(actuaciones == 0){
            accion = false;
            actuaciones = actTotal;
        }
    }    
    
    public void act(){
        if(accion)
            accion();
        else{
            Obstaculo obs = (Obstaculo)getOneIntersectingObject(Obstaculo.class);                
            if(obs !=null){
                    colisiono();
                    intercambiaImagenTransp();
                }
            else{
                super.act();
                setLocation(getX(), yIni);
            }
        }
    }
    
    public void colisiono(){
        if(!intersecto){
            Greenfoot.playSound("golpe.mp3");
            setImage("MayorX.png");
            escen.disminuyeVida();
            intersecto = true;
        }
    }
}
