import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;

/**
 * Write a description of class HijoMenor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class HijoMenor  extends Personaje
{
    private int rango;
    private boolean detenerObs;
    private int imagenObs;
    private int actuaciones;
    private int maxAct;
    
    
    public HijoMenor(){
        super("Menor",".png",3);
        teclaL = "f";
        teclaU = teclaL.toUpperCase();
        detenerObs = true;
        maxAct = actuaciones = 40;
        tecla = new Boton(teclaU,Color.green,maxAct);
        GreenfootImage aux = new Desnivel().getImage();
        double a = (double)((aux.getHeight()+1) * (aux.getHeight()+1) / 4);
        a += (double)((aux.getWidth()+1) * (aux.getWidth()+1) / 4);
        double b = (double)((getImage().getHeight()+1) * (getImage().getHeight()+1) / 4);
        b += (double)((getImage().getWidth()+1) * (getImage().getWidth()+1) / 4);
        a = Math.sqrt(a);
        b = Math.sqrt(b);
        rango =(int) Math.round(a + b);        
     
    } 
        
    public void addedToWorld(World world){
        escen = (Escenario)getWorld();
        escen.addObject(tecla, getX(), escen.getHeight()-24);
    }
    
    public void act(){
        accion();
        verificaAccion();
        reactivarObs();
        Desnivel obs = (Desnivel) getOneIntersectingObject(Desnivel.class);
        if(obs!=null ){
            detenerObs = true;
            obs.currentImage--;
            if(obs.currentImage > 3){
                if(!intersecto){  
                    Greenfoot.playSound("choque.mp3");
                    setImage("MenorX.png");
                    escen.disminuyeVida();
                }
                intercambiaImagenTransp();
            }
            intersecto = true;
        }
        else{
            super.act();
        }
    }
    
    public void accion(){
        if(accion){
            detenerObs = !detenerObs; 
            actuaciones = maxAct;
            accion = false;
            if(detenerObs) Greenfoot.playSound("acelerar.mp3");
            else Greenfoot.playSound("derrape.mp3");
        }
        List<Desnivel> obs = getWorld().getObjects(Desnivel.class);
        for(Desnivel it: obs){
            it.accion(detenerObs); 
        }
    }
    
    public void verificaAccion(){
        List<Desnivel> obs = getWorld().getObjects(Desnivel.class);
        if(obs.isEmpty()){
            detenerObs = true;
            actuaciones = maxAct;
        }
        if(detenerObs){
            tecla.restablecer();
        }
    }
    
    public boolean dameDetenerObs(){
        return detenerObs;
    }
    
    public void reactivarObs(){
        actuaciones--;
        if(actuaciones == 0 && !detenerObs){
            Greenfoot.playSound("acelerar.mp3");
            actuaciones = maxAct;
            detenerObs = true;
            escen.disminuyeVida();
        }
    }
}
