import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * Write a description of class Mensaje here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mensaje  extends Actor
{
    protected String texto;
    protected int descentCad;
    protected int ascentCad;
    protected int leadingCad;
    protected int widthCad;
    protected int heightCad;
    private int transparencia;
    private boolean noTransp;
    private int efecto;
    
    public Mensaje(float tamFuente, String texto,int efecto){
        this(tamFuente,texto,Color.black,efecto);
    }
    
    public Mensaje(float tamFuente, String texto, Color color,int efecto){
        this.efecto = efecto;
        noTransp = false;
        transparencia = 51;
        this.texto = texto;
        FontMetrics caractCad = generaCaractCad(tamFuente);
        calculaMedidas(caractCad, texto);
        GreenfootImage imagen = new GreenfootImage(widthCad, heightCad);
        Font fuente = imagen.getFont();
        imagen.setFont(fuente.deriveFont(tamFuente)); 
        imagen.setColor(color);
        imagen.drawString(texto,0,imagen.getHeight()-descentCad);
        setImage(imagen);        
    }
    
    public void act(){
        switch(efecto){
            case 1:
                efecto1();
                break;
            case 2:
                efecto2();
                break;
        }            
    }   
    
    public void efecto1(){       
        if(!noTransp){
            transparencia += 51;
            if(transparencia == 255)
                noTransp = true;
        }
        else
            transparencia -= 51;
        if(transparencia <= 0){
            getWorld().removeObject(this);
        }
        else{
            getImage().setTransparency(transparencia);
        }
    }
    
    public void efecto2(){
         if(!noTransp){
            transparencia += 51;
            if(transparencia >= 255)
                noTransp = true;
        }
        else{
            transparencia -= 51;
            if(transparencia <= 0)
                noTransp = false;
        }
        getImage().setTransparency(transparencia);
    }
    
    public FontMetrics generaCaractCad(float tamFuente){
        GreenfootImage imagen = new GreenfootImage(1,1);
        Image aux =(Image)imagen.getAwtImage();
        Font fuente = imagen.getFont();
        Graphics g = aux.getGraphics();
        g.setFont(fuente.deriveFont(tamFuente)); 
        return g.getFontMetrics();
    }
    
    public void calculaMedidas(FontMetrics fm, String texto){
        widthCad = fm.stringWidth(texto);
        heightCad = fm.getHeight();
        leadingCad = fm.getLeading();
        ascentCad = fm.getAscent();
        descentCad = fm.getDescent();
    }
        
}
