import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Contador extends Mensaje
{
    private int cont;
    
    public Contador(){
        this(100);
    }
    
    public Contador (int cantidad, String cad){
        super(24.0f,cad+" 100",0);
        cont = cantidad;        
        texto = cad+" ";
        actualizaContador();
    }
    
    public Contador(int cantidad){
        this(cantidad,"Rest:");
    }
    public void decrementa(){
        decrementa(1);
    }
    
    public void decrementa(int cantidad){
        if(cont - 1 >= 0)
        cont -= cantidad;
    }
    
    public void act (){
        actualizaContador();
    }
    public void actualizaContador()
    {
        GreenfootImage imagen = getImage();
        imagen.clear();
        imagen.drawString(texto + cont, 0,imagen.getHeight()-descentCad);
    }
    
    public int dameCuenta(){
        return cont;
    }
    
    public void reiniciaCont(int cantidad){
        cont = cantidad;
    }
}
