import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

public class PersonajeAnimado extends Actor
{
    protected GreenfootImage[] images;
    protected int currentImage = 0;
    protected String teclaL = "256";
    protected String teclaU = "256";
    protected boolean accion;
    
    public PersonajeAnimado(String basename, String suffix, int noOfImages)
    {
        images = new GreenfootImage[noOfImages];
        for(int i=0; i < noOfImages; i++) {
            images[i] = new GreenfootImage(basename + i + suffix);
        }
        setImage(images[currentImage]);
        
    }
    
    public void act() 
    {
        if(Greenfoot.isKeyDown(teclaL) || Greenfoot.isKeyDown(teclaU)){
            accion = true;
        }
        currentImage = (currentImage + 1) % images.length;
        setImage(images[currentImage]);
        getImage().setTransparency(255);
    }
    
}
